Name: festival
Summary: A free speech synthesizer
Version: 1.4.1
Release: 5

# Files needed for everything...
Source: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/%{name}-%{version}.tar.gz
Source1: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/speech_tools-1.2.1.tar.gz
Source2: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festdoc-1.4.0.1.tar.gz
Source3: speech_tools-config
Source5: festival-config
Source6: speech-tools-sparc.tar.bz2
Source10: ix86_RedHatLinux7.0.mak
Source11: alpha_RedHatLinux7.0.mak

### DICTIONARIES
# Generic English dictionary
Source100: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festlex_POSLEX.tar.gz
# American English dictionary
Source101: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festlex_CMU.tar.gz

### VOICES
# American English male speaker (KAL), residual excited LPC diphone database
Source200: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kallpc16k.tar.gz
# Same voice at lower quality
Source201: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kallpc8k.tar.gz
# American English male speaker, residual excited LPC diphone database
Source202: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kedlpc16k.tar.gz
# Same voice at lower quality
Source203: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kedlpc8k.tar.gz
# Castilian Spanish male speaker, residual excited LPC diphone database
Source204: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_ellpc11k.tar.gz

# Fix up various locations to be more FSSTND compliant
Patch: festival-1.4.1-fsstnd.patch

# Set defaults to American English instead of British English - the OALD
# dictionary (free for non-commercial use only) is needed for BE support
Patch1: festival-american.patch

# Fix the "No at end of sentence == Number" bug
Patch2: festival-bug.patch

# Fix compilation
Patch3: festival-gcc296.patch

# Add some useful words to the dictionary...
Patch10: CMU-redhat.patch

URL: http://www.speech.cs.cmu.edu/festival/
Group: Applications/Multimedia
License: BSD
BuildRoot: /var/tmp/%{name}-buildroot
Prefix: /usr

ExclusiveArch: i386 i485 i586 i686 i786 i886 i986 alpha

%package devel
Requires: %{name} = %{version}
Summary: Development files for the festival speech synthesizer
Group: Development/Libraries

%description
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

%description devel
Development files for the festival speech synthesizer. Install
%{name}-devel if you want to use the festival speech synthesizer from
within your own progrmas and/or if you intend to compile other programs
using it.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n festival -a 1 -a 6
%patch -p1 -b .fsstnd
%patch1 -p1 -b .americandefault
%patch2 -p1
%patch3 -p1 -b .compile

%build
export PATH=`pwd`/src/main:$PATH
export LD_LIBRARY_PATH=`pwd`/speech_tools/lib:$PATH
cd speech_tools
cp %{SOURCE3} config/config
cp %{SOURCE10} config/systems/ix86_RedHatLinux7.0.mak
cp %{SOURCE11} config/systems/alpha_RedHatLinux7.0.mak

RELEASE=`cat /etc/redhat-release |awk '{ print $5; };'`

for i in config/systems/*RedHatLinux7.0.mak; do
  cp $i `echo $i |sed -e "s,7\.0,$RELEASE,g"`
done
chmod +w config/config
make EST_HOME=$RPM_BUILD_ROOT%{prefix}/share/festival
cd ..
cp %{SOURCE5} config/config
chmod +w config/config
make

mkdir src/lib/evil.hack
cd src/lib/evil.hack
ar x ../libFestival.a
g++ -shared -L../../../speech_tools/lib -lestools -lestbase -leststring -ltermcap -Wl,-soname -Wl,libFestival.so.1 -Wl,--rpath -Wl,%{prefix}/lib -o ../libFestival.so.1.4.1 *
cd ../../..
rm -rf src/lib/evil.hack

mkdir DATA.TMP
cd DATA.TMP
tar xzf %{SOURCE100}
tar xzf %{SOURCE101}
tar xzf %{SOURCE200}
tar xzf %{SOURCE201}
tar xzf %{SOURCE202}
tar xzf %{SOURCE203}
tar xzf %{SOURCE204}
patch -p0 <%{PATCH10}
cd festival/lib/dicts/cmu
make
cd ../../..

%install
export PATH=`pwd`/src/main:$PATH
export LD_LIBRARY_PATH=`pwd`/speech_tools/lib:$PATH
mkdir -p $RPM_BUILD_ROOT%{prefix}/bin $RPM_BUILD_ROOT%{prefix}/lib
cd speech_tools
rm -f bin/Makefile
cp -a bin/* $RPM_BUILD_ROOT%{prefix}/bin
cp -a lib/lib*.a $RPM_BUILD_ROOT%{prefix}/lib
cp -a lib/lib*.so.* $RPM_BUILD_ROOT%{prefix}/lib
cp -a lib/lib*.so $RPM_BUILD_ROOT%{prefix}/lib
cd ..
mkdir -p $RPM_BUILD_ROOT%{prefix}/share/festival
mv DATA.TMP/festival/lib/voices $RPM_BUILD_ROOT%{prefix}/share/festival
mv DATA.TMP/festival/lib/dicts $RPM_BUILD_ROOT%{prefix}/share/festival
rm -f lib/Makefile lib/*.fsstnd lib/*.americandefault bin/Makefile
mv lib/* $RPM_BUILD_ROOT%{prefix}/share/festival
mv bin/* $RPM_BUILD_ROOT%{prefix}/bin
# We want the real festival, not the wrapper script
cp -af src/main/festival $RPM_BUILD_ROOT%{prefix}/bin
rm -f $RPM_BUILD_ROOT%{prefix}/bin/Makefile
mkdir -p $RPM_BUILD_ROOT%{prefix}/man/man1
cp -a doc/*.1 $RPM_BUILD_ROOT%{prefix}/man/man1

mkdir -p $RPM_BUILD_ROOT%{prefix}/include/speech_tools
mkdir -p $RPM_BUILD_ROOT%{prefix}/include/festival
cp -a src/include/* $RPM_BUILD_ROOT%{prefix}/include/festival
cp -aR speech_tools/include/* $RPM_BUILD_ROOT%{prefix}/include/speech_tools
cp -a src/lib/libFestival.a $RPM_BUILD_ROOT%{prefix}/lib
cp -a src/lib/libFestival.so.%{version} $RPM_BUILD_ROOT%{prefix}/lib
ln -sf libFestival.so.%{version} $RPM_BUILD_ROOT%{prefix}/lib/libFestival.so.1
ln -sf libFestival.so.%{version} $RPM_BUILD_ROOT%{prefix}/lib/libFestival.so

# Remove some crap we don't need
rm -rf $RPM_BUILD_ROOT%{prefix}/include/speech_tools/win32
rm -rf $RPM_BUILD_ROOT%{prefix}/include/speech_tools/Makefile
rm -rf $RPM_BUILD_ROOT%{prefix}/include/festival/Makefile

# Fix up the headers to look for other includes where we want them, not
# where they're supposed to be in the source tree
# There is probably a better way to do this, I'm not (yet) a sed expert.
# What this does is, basically, replacing "EST_*.h" with <speech_tools/EST_*.h>.
for i in `find $RPM_BUILD_ROOT%{prefix}/include/festival/ -type f` `find $RPM_BUILD_ROOT%{prefix}/include/speech_tools/ -type f`; do
  sed -e 's,"EST.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/\",speech_tools/,g' \
	-e 's,"siod.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/\",speech_tools/,g' \
	-e 's,"instantiate/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/instantiate/\",speech_tools/instantiate/,g' -e 's,"instantiate,instantiate,g' \
	-e 's,"ling_class/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/ling_class/\",speech_tools/ling_class/,g' -e 's,"ling_class,ling_class,g'\
	-e 's,"rxp/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/rxp/\",speech_tools/rxp/,g' -e 's,"rxp,rxp,g' \
  	-e 's,"sigpr/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/sigpr/\",speech_tools/sigpr/,g' -e 's,"sigpr,sigpr,g' \
	-e 's,"unix/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/unix/\",speech_tools/unix/,g' -e 's,\.h\">,.h\>,g' -e 's,"unix,unix,g' \
	-e 's,"festival\.h",\<festival/festival.h\>,g' \
  	-e 's,"ModuleDescription\.h",\<festival/ModuleDescription.h\>,g' \
  	-e 's,"Phone\.h",\<festival/Phone.h\>,g' $i >$i-redhat
  mv -f $i-redhat $i
done
[ %{_mandir} != /usr/man ] && {
	mkdir -p $RPM_BUILD_ROOT%{_mandir}
	mv $RPM_BUILD_ROOT/usr/man/* $RPM_BUILD_ROOT%{_mandir}
	rm -rf $RPM_BUILD_ROOT/usr/man
}

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc festdoc-1.4.0.1/festival/user-manual
%doc festdoc-1.4.0.1/festival/info
%doc festdoc-1.4.0.1/festival/festival.ps
%doc festdoc-1.4.0.1/festival/festival.dvi
# stuff from speech_tools
%{prefix}/bin/align
%{prefix}/bin/bcat
%{prefix}/bin/build_docbook_index
%{prefix}/bin/ch_lab
%{prefix}/bin/ch_track
%{prefix}/bin/ch_utt
%{prefix}/bin/ch_wave
%{prefix}/bin/cxx_to_docbook
%{prefix}/bin/design_filter
%{prefix}/bin/dp
%{prefix}/bin/est_examples
%{prefix}/bin/est_gdb
%{prefix}/bin/est_program
%{prefix}/bin/example_to_doc++
%{prefix}/bin/fringe_client
%{prefix}/bin/make_wagon_desc
%{prefix}/bin/na_play
%{prefix}/bin/na_record
%{prefix}/bin/ngram_build
%{prefix}/bin/ngram_test
%{prefix}/bin/ols
%{prefix}/bin/ols_test
%{prefix}/bin/pda
%{prefix}/bin/pitchmark
%{prefix}/bin/pm
%{prefix}/bin/raw_to_xgraph
%{prefix}/bin/resynth
%{prefix}/bin/scfg_make
%{prefix}/bin/scfg_parse
%{prefix}/bin/scfg_test
%{prefix}/bin/scfg_train
%{prefix}/bin/sig2fv
%{prefix}/bin/sigfilter
%{prefix}/bin/siod
%{prefix}/bin/spectgen
%{prefix}/bin/tex_to_images
%{prefix}/bin/tilt_analysis
%{prefix}/bin/tilt_synthesis
%{prefix}/bin/viterbi
%{prefix}/bin/wagon
%{prefix}/bin/wagon_test
%{prefix}/bin/wfst_build
%{prefix}/bin/wfst_run
%{prefix}/bin/xml_parser
%{prefix}/lib/libes*.so*
# Actual festival stuff
%{prefix}/bin/festival*
%{prefix}/share/festival
%{prefix}/lib/libFest*.so*
%{_mandir}/man1/*

%files devel
%defattr(-,root,root)
%doc festdoc-1.4.0.1/festival/src-manual
%doc festdoc-1.4.0.1/speechtools
%{prefix}/lib/*.a
%dir %{prefix}/include/speech_tools
%dir %{prefix}/include/festival
%{prefix}/include/speech_tools/*
%{prefix}/include/festival/*

%changelog
* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add defattr (Bug #15033)

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Mon Jul 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Thu Jul  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- FHSify

* Mon Jun 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on non-x86

* Sun Apr 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- initial packaging
